(in-package :feuer)


;(defparameter *default-texture* (make-png-texture "/home/cupe/projects/feuer/default.png"))
(defparameter *default-texture* (make-text-texture "foo" 128 128 48))

(declaim (optimize (debug 3)))

(defclass* 2d-quad (drawable)
  ((pos (vec2 0 0))
   (size 1.0)
   (rotation 0)
   (color '(1 1 1 1))
   ;(alpha 1) ;todo: use?
   (texture *default-texture*)))

(defmethod draw ((quad 2d-quad) &key)
  (with-pushed-matrix (:modelview)
    (translate (pos-of quad))
    (rotate (rotation-of quad) (vec3 0 0 1))
    (scale (size-of quad))
    (bind-texture (texture-of quad))
    (color (color-of quad))
    (gl:with-primitives :quads
      (dolist (corner '((-0.5 -0.5  0    1  0)
                        (-0.5  0.5  0    1  1)
                        ( 0.5  0.5  0    0  1)
                        ( 0.5 -0.5  0    0  0)))
        (destructuring-bind (x y z u v) corner
          (gl:tex-coord u v)
          (gl:vertex x y z))))))



(defclass* 2d-window (glut:window)
  ((ticks 0)
   (topleft (vec2 -0.5 -0.5))
   (bottomright (vec2 0.5 0.5))))

(defmethod glut:display-window :before ((w 2d-window))
  (gl:enable :texture-2d)
  (reinit *default-texture*))


(defmethod update-projection ((window 2d-window))
  (with-matrix-mode (:projection)
    (let* ((width (glut:width window))
           (height (glut:height window))
           (aspect (/ width height))
           ;;todo: hier wird nur nach hoehe des windows gescaled, muss minimum werden
           (area-size (v- (bottomright-of window)
                          (topleft-of window)))
           (area-aspect (/ (x area-size)
                           (y area-size)))
           (left (* (x (topleft-of window))  aspect (/ area-aspect)))
           (right (* (x (bottomright-of window))    aspect (/ area-aspect)))
           (bottom (* (y (bottomright-of window))  ))
           (top (* (y (topleft-of window)))))
      (gl:load-identity)
      (gl:ortho left right bottom top
                -100 100))))

(defmethod glut:reshape ((window 2d-window) width height)
  (setf (glut:width window) width
        (glut:height window) height)
  
  (update-projection window)
  (gl:viewport 0 0 width height)
  (glut:post-redisplay))

(defmethod glut:display :around ((window 2d-window))
  (incf (ticks-of window))
  (with-pushed-matrix (:modelview)
    (gl:load-identity)
    (glu:look-at 0 0 -1  0 0 0  0 1 0)
    (call-next-method)))

